package betterwithmods.common.blocks;

import betterwithmods.common.BWMBlocks;
import betterwithmods.util.DirUtils;
import betterwithmods.util.InvUtils;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.state.BlockFaceShape;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockRenderLayer;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

import javax.annotation.Nonnull;

import static net.minecraft.util.EnumFacing.Axis.*;


/**
 * Created by primetoxinz on 5/17/17.
 */
public class BlockStake extends BWMBlock {


    public BlockStake() {
        super(Material.field_151575_d);
        func_180632_j(func_176223_P().func_177226_a(DirUtils.NORTH, false).func_177226_a(DirUtils.SOUTH, false).func_177226_a(DirUtils.WEST, false).func_177226_a(DirUtils.EAST, false).func_177226_a(DirUtils.UP, false).func_177226_a(DirUtils.DOWN, false));
    }

    @Nonnull
    @Override
    public IBlockState getStateForPlacement(@Nonnull World world, @Nonnull BlockPos pos, @Nonnull EnumFacing facing, float hitX, float hitY, float hitZ, int meta, @Nonnull EntityLivingBase placer, EnumHand hand) {
        return func_176223_P().func_177226_a(DirUtils.FACING, facing.func_176734_d());
    }

    @Nonnull
    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, DirUtils.FACING, DirUtils.UP, DirUtils.DOWN, DirUtils.NORTH, DirUtils.SOUTH, DirUtils.WEST, DirUtils.EAST);
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return state.func_177229_b(DirUtils.FACING).func_176745_a();
    }

    @Nonnull
    @Override
    public IBlockState func_176203_a(int meta) {
        return func_176223_P().func_177226_a(DirUtils.FACING, EnumFacing.func_82600_a(meta));
    }


    public boolean func_149686_d(IBlockState state) {
        return false;
    }

    public boolean func_149662_c(IBlockState state) {
        return false;
    }

    @Override
    public boolean func_180639_a(World worldIn, BlockPos pos, IBlockState state, EntityPlayer playerIn, EnumHand hand, EnumFacing side, float hitX, float hitY, float hitZ) {
        ItemStack stack = playerIn.func_184614_ca();
        if (stack.func_77969_a(new ItemStack(Items.field_151007_F)))
            return placeString(worldIn, pos, side, stack);
        return false;
    }

    public boolean placeString(World world, BlockPos pos, EnumFacing facing, ItemStack stack) {
        int count = stack.func_190916_E();
        int build = -1;
        for (int i = 1; i <= 64; i++) {
            IBlockState stake = world.func_180495_p(pos.func_177967_a(facing, i));
            if (stake.func_177230_c() instanceof BlockStake) {
                build = i;
                break;
            }
            else if (!world.func_175623_d(pos.func_177967_a(facing, i)) && !stake.func_177230_c().func_176200_f(world, pos.func_177967_a(facing, i)) && stake.func_177230_c() != BWMBlocks.STAKE_STRING)
                return false;
        }
        if (build > -1 && count >= (build - 1)) {
            int remove = 0;
            //stack.shrink(build - 1);
            for (int i = 1; i < build; i++) {
                if (world.func_180495_p(pos.func_177967_a(facing, i)).func_177230_c() != BWMBlocks.STAKE_STRING) {
                    world.func_175656_a(pos.func_177967_a(facing, i), BWMBlocks.STAKE_STRING.func_176223_P());
                    remove++;
                }
            }
            stack.func_190918_g(remove);
            return true;
        }
        return false;
    }


    @Nonnull
    @Override
    public AxisAlignedBB func_185496_a(IBlockState state, IBlockAccess source, BlockPos pos) {
        switch (state.func_177229_b(DirUtils.FACING)) {

            default:
                return new AxisAlignedBB(6 / 16f, 0, 6 / 16f, 10f / 16, 12f / 16f, 10f / 16f);
            case UP:
                return new AxisAlignedBB(6 / 16f, 4 / 16f, 6 / 16f, 10f / 16, 1, 10f / 16f);
            case NORTH:
                return new AxisAlignedBB(6 / 16f, 6 / 16f, 12f / 16f, 10f / 16f, 10f / 16, 0);
            case SOUTH:
                return new AxisAlignedBB(6 / 16f, 6 / 16f, 4f / 16f, 10f / 16f, 10f / 16, 1);
            case WEST:
                return new AxisAlignedBB(12f / 16f, 6 / 16f, 6 / 16f, 0, 10f / 16, 10f / 16f);
            case EAST:
                return new AxisAlignedBB(4f / 16f, 6 / 16f, 6 / 16f, 1, 10f / 16, 10f / 16f);

        }
    }

    public static final PropertyBool[] Z_ROTATE = new PropertyBool[]{DirUtils.SOUTH, DirUtils.NORTH, DirUtils.DOWN, DirUtils.UP, DirUtils.EAST, DirUtils.WEST};
    public static final PropertyBool[] X_ROTATE = new PropertyBool[]{DirUtils.SOUTH, DirUtils.NORTH, DirUtils.WEST, DirUtils.EAST, DirUtils.DOWN, DirUtils.UP};

    @Nonnull
    @Override
    public IBlockState func_176221_a(@Nonnull IBlockState state, IBlockAccess worldIn, BlockPos pos) {
        IBlockState newState = state;
        EnumFacing facing = state.func_177229_b(DirUtils.FACING);
        EnumFacing.Axis axis = facing.func_176740_k();

        boolean inverted = facing.func_176743_c() == EnumFacing.AxisDirection.POSITIVE; //so technically not inverted.
        PropertyBool[] transform = DirUtils.DIR_PROP;
        if (axis == Z)
            transform = Z_ROTATE;
        else if (axis == X)
            transform = X_ROTATE;

        for (int i = 0; i < EnumFacing.field_82609_l.length; i++) {
            EnumFacing front = EnumFacing.func_82600_a(i);
            if(inverted && ((axis != Y && front.func_176740_k() != Y) || (axis == Y && front.func_176740_k() != X))) //Dude idk why but it needs this.
                front = front.func_176734_d();
            newState = newState.func_177226_a(transform[i], getDirection(worldIn, pos, front));
        }
        return newState;
    }

    public static boolean getDirection(IBlockAccess world, BlockPos pos, EnumFacing facing) {
        Block block = world.func_180495_p(pos.func_177972_a(facing)).func_177230_c();
        return block instanceof BlockStakeString;
    }

    @Nonnull
    @Override
    public BlockRenderLayer func_180664_k() {
        return BlockRenderLayer.CUTOUT_MIPPED;
    }

    @Nonnull
    @Override
    public BlockFaceShape func_193383_a(IBlockAccess p_193383_1_, IBlockState p_193383_2_, BlockPos p_193383_3_, EnumFacing p_193383_4_) {
        return BlockFaceShape.UNDEFINED;
    }

    @Override
    public boolean isSideSolid(IBlockState base_state, @Nonnull IBlockAccess world, @Nonnull BlockPos pos, EnumFacing side) {
        return false;
    }

    @Override
    public boolean func_176198_a(@Nonnull World worldIn, @Nonnull BlockPos pos, EnumFacing side) {
        return worldIn.isSideSolid(pos.func_177972_a(side.func_176734_d()),side);
    }

    @Override
    public void func_180663_b(@Nonnull World worldIn, @Nonnull BlockPos pos, @Nonnull IBlockState state) {
        worldIn.func_175685_c(pos, this, true);
        for (EnumFacing facing : EnumFacing.field_82609_l) {
            Block block = worldIn.func_180495_p(pos.func_177972_a(facing)).func_177230_c();
            if (block instanceof BlockStakeString) {
                ((BlockStakeString) block).drop(worldIn, pos.func_177972_a(facing));
            }
        }
        super.func_180663_b(worldIn, pos, state);
    }

    public boolean isSupported(World world, BlockPos pos, IBlockState state) {
        EnumFacing side = state.func_177229_b(DirUtils.FACING);
        return world.isSideSolid(pos.func_177972_a(side), side.func_176734_d());
    }

    @Override
    public void func_189540_a(IBlockState state, World worldIn, BlockPos pos, Block blockIn, BlockPos fromPos) {
        if(!isSupported(worldIn,pos,state)) {
            InvUtils.ejectStackWithOffset(worldIn,pos,func_185473_a(worldIn,pos,state));
            worldIn.func_175698_g(pos);
        }
    }
}
