package betterwithmods.common.blocks.mechanical.mech_machine;

import betterwithmods.BWMod;
import betterwithmods.common.blocks.mechanical.tile.TileTurntable;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyInteger;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraft.world.storage.loot.LootTableList;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.Random;

public class BlockTurntable extends BlockMechMachine {
    public static final ResourceLocation TURNTABLE = LootTableList.func_186375_a(new ResourceLocation(BWMod.MODID, "block/turntable"));
    public static final PropertyInteger SPEED = PropertyInteger.func_177719_a("speed", 0, 3);

    public BlockTurntable() {
        super(Material.field_151575_d, TURNTABLE);
        field_149783_u = true;
    }

    @Nonnull
    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, SPEED, ACTIVE);
    }

    @Nullable
    @Override
    public TileEntity createTileEntity(@Nonnull World world, @Nonnull IBlockState state) {
        return new TileTurntable();
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand, EnumFacing side, float hitX, float hitY, float hitZ) {
        if (world.func_175625_s(pos) instanceof TileTurntable) {
            return ((TileTurntable) world.func_175625_s(pos)).processRightClick(player);
        }
        return true;
    }

    @Override
    public void func_180650_b(World world, BlockPos pos, IBlockState state, Random rand) {
        if (world.func_175625_s(pos) instanceof TileTurntable) {
            if (!world.func_82736_K().func_82766_b("doDaylightCycle"))
                ((TileTurntable) world.func_175625_s(pos)).toggleAsynchronous(null);
        }
    }

    @Nonnull
    @Override
    public IBlockState func_176221_a(@Nonnull IBlockState state, IBlockAccess world, BlockPos pos) {
        if (world.func_175625_s(pos) instanceof TileTurntable) {
            TileTurntable tile = (TileTurntable) world.func_175625_s(pos);
            return state.func_177226_a(SPEED, tile.getTimerPos());
        }
        return state;
    }
}
