package betterwithmods.common.blocks.tile;

import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import javax.annotation.Nonnull;

public class TileBlockDispenser extends TileBasicInventory {
    public int nextIndex;

    public TileBlockDispenser() {
        this.nextIndex = 0;
    }

    @Override
    public boolean shouldRefresh(World world, BlockPos pos, @Nonnull IBlockState oldState, @Nonnull IBlockState newState) {
        return oldState.func_177230_c() != newState.func_177230_c();
    }

    @Override
    public void func_145839_a(NBTTagCompound tag) {
        super.func_145839_a(tag);
        if (tag.func_74764_b("NextSlot"))
            this.nextIndex = tag.func_74762_e("NextSlot");
    }

    @Override
    public int getInventorySize() {
        return 16;
    }

    @Nonnull
    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound tag) {
        NBTTagCompound t = super.func_189515_b(tag);
        t.func_74768_a("NextSlot", this.nextIndex);
        return t;
    }

    public void addStackToInventory(ItemStack stack, BlockPos pos) {
        if (stack .func_190926_b() ) return;
        for (int i = 0; i < 16; i++) {
            ItemStack check = this.inventory.getStackInSlot(i);
            if (!check.func_190926_b()) {
                if (ItemStack.func_179545_c(stack, check) && check.func_190916_E() < check.func_77976_d()) {
                    if (check.func_77942_o() || stack.func_77942_o()) {
                        if (!ItemStack.func_77970_a(stack, check))
                            continue;
                    }
                    check.func_190917_f(1);
                    this.inventory.setStackInSlot(i, check);
                    return;
                }
            }
        }
        int firstSlot = findFirstNullStack();
        if (firstSlot > -1) {
            this.inventory.setStackInSlot(firstSlot, stack);
        } else {
            EntityItem item = new EntityItem(func_145831_w(), pos.func_177958_n() + 0.5D, pos.func_177956_o() + 0.5D, pos.func_177952_p() + 0.5D, stack);
            item.func_174869_p();
            func_145831_w().func_72838_d(item);
        }
    }

    private int findFirstNullStack() {
        for (int i = 0; i < 16; i++) {
            if (this.inventory.getStackInSlot(i).func_190926_b())
                return i;
        }
        return -1;
    }

    public ItemStack getCurrentSlot() {
        return inventory.getStackInSlot(nextIndex%16);
    }

    public ItemStack getNextStackFromInv() {
        ItemStack nextStack;

        if (this.nextIndex >= this.inventory.getSlots() || this.inventory.getStackInSlot(this.nextIndex) .func_190926_b() ) {
            int slot = findNextValidSlot(this.nextIndex);

            if (slot < 0)
                return ItemStack.field_190927_a;

            this.nextIndex = slot;
        }

        nextStack = this.inventory.getStackInSlot(this.nextIndex);

        int slot = findNextValidSlot(this.nextIndex);

        if (slot < 0)
            this.nextIndex = 0;
        else
            this.nextIndex = slot;

        return nextStack;
    }

    private int findNextValidSlot(int currentSlot) {
        for (int slot = currentSlot + 1; slot < this.inventory.getSlots(); slot++) {
            if (!this.inventory.getStackInSlot(slot).func_190926_b())
                return slot;
        }

        for (int slot = 0; slot < currentSlot; slot++) {
            if (!this.inventory.getStackInSlot(slot).func_190926_b())
                return slot;
        }

        if (!this.inventory.getStackInSlot(currentSlot).func_190926_b())
            return currentSlot;

        return -1;
    }

    public boolean isUseableByPlayer(EntityPlayer player) {
        return this.func_145831_w().func_175625_s(this.field_174879_c) == this && player.func_70092_e(this.field_174879_c.func_177958_n() + 0.5D, this.field_174879_c.func_177956_o() + 0.5D, this.field_174879_c.func_177952_p() + 0.5D) <= 64.0D;
    }

}
