package betterwithmods.common.blocks.tile;

import net.minecraft.block.state.IBlockState;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.ITickable;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import javax.annotation.Nonnull;

public abstract class TileVisibleInventory extends TileBasicInventory implements ITickable {
    public short occupiedSlots;
    private int facing;

    @Override
    public boolean shouldRefresh(World world, BlockPos pos, @Nonnull IBlockState oldState, @Nonnull IBlockState newState) {
        return oldState.func_177230_c() != newState.func_177230_c();
    }

    public int getFacing() {
        return this.facing;
    }

    public void setFacing(int facing) {
        this.facing = facing;
    }

    @Override
    public void func_145839_a(NBTTagCompound tag) {
        super.func_145839_a(tag);
        this.facing = tag.func_74771_c("facing");
    }

    @Nonnull
    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound tag) {
        NBTTagCompound t = super.func_189515_b(tag);
        t.func_74774_a("facing", (byte) this.facing);
        return t;
    }

    public int filledSlots() {
        int fill = 0;
        for (int i = 0; i < this.getMaxVisibleSlots(); i++) {
            if (!inventory.getStackInSlot(i).func_190926_b())
                fill++;
        }
        return fill;
    }

    public abstract String getName();

    //Mostly for aesthetic purposes, primarily so the filter in the filtered hopper doesn't reclaimCount.
    public abstract int getMaxVisibleSlots();

}
