package betterwithmods.common.items;

import betterwithmods.api.util.IBlockVariants;
import betterwithmods.client.BWCreativeTabs;
import betterwithmods.common.BWMRecipes;
import betterwithmods.common.BWOreDictionary;
import net.minecraft.block.state.IBlockState;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTUtil;
import net.minecraft.util.NonNullList;
import net.minecraft.util.text.ITextComponent;
import net.minecraft.util.text.TextComponentString;
import net.minecraft.util.text.TextComponentTranslation;

import javax.annotation.Nonnull;
import java.util.List;
import java.util.stream.Collectors;

public class ItemBark extends Item {

    public ItemBark() {
        super();
        this.func_77637_a(BWCreativeTabs.BWTAB);
        this.func_77627_a(true);
    }

    public static ItemStack fromParentStack(Item bark, ItemStack log, int count) {
        ItemStack stack = new ItemStack(bark, count);
        NBTTagCompound tag = new NBTTagCompound();
        NBTTagCompound texture = new NBTTagCompound();
        NBTUtil.func_190009_a(texture, BWMRecipes.getStateFromStack(log));
        tag.func_74782_a("texture", texture);
        stack.func_77982_d(tag);
        return stack;
    }

    public static List<ItemStack> getBarks(int count) {
        return BWOreDictionary.blockVariants.stream().map(b -> b.getVariant(IBlockVariants.EnumBlock.BARK, count)).filter(s -> !s.func_190926_b()).collect(Collectors.toList());
    }

    @Override
    public int getItemBurnTime(ItemStack itemStack) {
        return 25;
    }

    public List<ItemStack> getLogs() {
        return BWOreDictionary.blockVariants.stream().map(b -> b.getVariant(IBlockVariants.EnumBlock.LOG, 1)).filter(s -> !s.func_190926_b()).collect(Collectors.toList());
    }

    @Override
    public void func_150895_a(@Nonnull CreativeTabs tab, @Nonnull NonNullList<ItemStack> items) {
        if (func_194125_a(tab)) {
            List<ItemStack> logs = getLogs();
            for (ItemStack log : logs) {
                items.add(fromParentStack(this, log, 1));
            }
        }
    }

    @Nonnull
    @Override
    public String func_77653_i(@Nonnull ItemStack stack) {
        NBTTagCompound tag = stack.func_179543_a("texture");
        ITextComponent type = new TextComponentTranslation("betterwithmods.unknown_bark.name");
        //TODO .name is not longer in 1.13
        ITextComponent bark = new TextComponentTranslation(this.func_77667_c(stack) + ".name");
        if (tag != null) {
            try {
                IBlockState state = NBTUtil.func_190008_d(tag);
                ItemStack block = new ItemStack(state.func_177230_c(), 1, state.func_177230_c().func_176201_c(state));
                if (block.func_77973_b() instanceof ItemBlock) {
                    ItemBlock itemBlock = (ItemBlock) block.func_77973_b();
                    type = new TextComponentString(itemBlock.func_77653_i(block));
                }
            } catch (NullPointerException e) {
                e.printStackTrace();
            }
        }

        return type.func_150258_a(" ").func_150257_a(bark).func_150254_d();
    }
}
