package betterwithmods.common.registry;

import betterwithmods.common.BWMBlocks;
import betterwithmods.common.BWOreDictionary;
import betterwithmods.common.items.ItemMaterial;
import betterwithmods.util.IngredientMap;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;

/**
 * Created by primetoxinz on 6/29/17.
 */
public class BellowsManager {

    public static final IngredientMap<Float> bellowing = new IngredientMap<>(-1f);

    public static float getWeight(ItemStack stack) {
        return bellowing.findValue(stack);
    }



    public static void postInit() {
        bellowing.put(Items.field_151016_H, 3f);
        bellowing.put(Items.field_151121_aF, 3f);
        bellowing.put(Items.field_151148_bJ, 3f);
        bellowing.put(Items.field_151098_aY, 3f);
        bellowing.put(Items.field_151008_G, 3f);
        bellowing.put(Items.field_151102_aT, 3f);
        bellowing.put("foodFlour", 3f);
        bellowing.put(ItemMaterial.getStack(ItemMaterial.EnumMaterial.GROUND_NETHERRACK), 2f);
        bellowing.put(ItemMaterial.getStack(ItemMaterial.EnumMaterial.HEMP_LEAF), 2f);
        bellowing.put(ItemMaterial.getStack(ItemMaterial.EnumMaterial.HEMP_FIBERS), 2f);
        bellowing.put(new ItemStack(BWMBlocks.HEMP), 2f);
        bellowing.put(Items.field_185163_cU, 2f);
        bellowing.put(Items.field_151081_bc, 2f);
        bellowing.put(Items.field_151080_bb, 2f);
        bellowing.put(Items.field_151014_N, 2f);
        bellowing.put(Items.field_151007_F, 2f);
        bellowing.put(Items.field_151100_aR, 2f);
        bellowing.put(Items.field_151015_O, 1f);
        bellowing.put(Items.field_151075_bm, 1f);
        bellowing.put(Items.field_151032_g, 1f);
        bellowing.put(Items.field_185167_i, 1f);
        bellowing.put(Items.field_185166_h, 1f);
        bellowing.put(ItemMaterial.getStack(ItemMaterial.EnumMaterial.ELEMENT), 2f);
        bellowing.put(ItemMaterial.getStack(ItemMaterial.EnumMaterial.FILAMENT), 2f);
        bellowing.put(ItemMaterial.getStack(ItemMaterial.EnumMaterial.LEATHER_STRAP), 2f);

        BWOreDictionary.dustNames.forEach(ore -> bellowing.put(ore, 3f));
    }


}
