package betterwithmods.common.world.gen.village;

import net.minecraft.block.BlockStairs;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.MathHelper;
import net.minecraft.world.World;
import net.minecraft.world.gen.structure.StructureBoundingBox;
import net.minecraft.world.gen.structure.StructureComponent;
import net.minecraft.world.gen.structure.StructureVillagePieces;

import javax.annotation.Nonnull;
import java.util.List;
import java.util.Random;

/**
 * Created by primetoxinz on 5/25/17.
 */
public class House extends AbandonedVillagePiece {
    public House() {
    }

    public House(StructureVillagePieces.Start start, int type, Random rand, StructureBoundingBox p_i45561_4_, EnumFacing facing) {
        super(start, type);
        this.func_186164_a(facing);
        this.field_74887_e = p_i45561_4_;
    }


    /**
     * second Part of Structure generating, this for example places Spiderwebs, Mob Spawners, it closes
     * Mineshafts at the end, it adds Fences...
     */
    public boolean func_74875_a(@Nonnull World worldIn, @Nonnull Random randomIn, @Nonnull StructureBoundingBox structureBoundingBoxIn) {
        if (this.field_143015_k < 0) {
            this.field_143015_k = this.func_74889_b(worldIn, structureBoundingBoxIn);

            if (this.field_143015_k < 0) {
                return true;
            }

            this.field_74887_e.func_78886_a(0, this.field_143015_k - this.field_74887_e.field_78894_e + 7 - 1, 0);
        }

        IBlockState iblockstate = this.func_175847_a(Blocks.field_150347_e.func_176223_P());
        IBlockState iblockstate1 = this.func_175847_a(Blocks.field_150476_ad.func_176223_P().func_177226_a(BlockStairs.field_176309_a, EnumFacing.NORTH));
        IBlockState iblockstate2 = this.func_175847_a(Blocks.field_150476_ad.func_176223_P().func_177226_a(BlockStairs.field_176309_a, EnumFacing.SOUTH));
        IBlockState iblockstate3 = this.func_175847_a(Blocks.field_150476_ad.func_176223_P().func_177226_a(BlockStairs.field_176309_a, EnumFacing.EAST));
        IBlockState iblockstate4 = this.func_175847_a(Blocks.field_150476_ad.func_176223_P().func_177226_a(BlockStairs.field_176309_a, EnumFacing.WEST));
        IBlockState iblockstate5 = this.func_175847_a(Blocks.field_150344_f.func_176223_P());
        IBlockState iblockstate6 = this.func_175847_a(Blocks.field_150364_r.func_176223_P());
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 1, 1, 7, 4, 4, Blocks.field_150350_a.func_176223_P(), Blocks.field_150350_a.func_176223_P(), false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 2, 1, 6, 8, 4, 10, Blocks.field_150350_a.func_176223_P(), Blocks.field_150350_a.func_176223_P(), false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 2, 0, 5, 8, 0, 10, iblockstate5, iblockstate5, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 0, 1, 7, 0, 4, iblockstate5, iblockstate5, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 0, 0, 0, 3, 5, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 8, 0, 0, 8, 3, 10, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 0, 0, 7, 2, 0, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 0, 5, 2, 1, 5, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 2, 0, 6, 2, 3, 10, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 3, 0, 10, 7, 3, 10, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 2, 0, 7, 3, 0, iblockstate5, iblockstate5, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 2, 5, 2, 3, 5, iblockstate5, iblockstate5, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 4, 1, 8, 4, 1, iblockstate5, iblockstate5, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 4, 4, 3, 4, 4, iblockstate5, iblockstate5, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 5, 2, 8, 5, 3, iblockstate5, iblockstate5, false);
        this.func_175811_a(worldIn, iblockstate5, 0, 4, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate5, 0, 4, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate5, 8, 4, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate5, 8, 4, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate5, 8, 4, 4, structureBoundingBoxIn);

        for (int i = -1; i <= 2; ++i) {
            for (int j = 0; j <= 8; ++j) {
                this.func_175811_a(worldIn, iblockstate1, j, 4 + i, i, structureBoundingBoxIn);

                if ((i > -1 || j <= 1) && (i > 0 || j <= 3) && (i > 1 || j <= 4 || j >= 6)) {
                    this.func_175811_a(worldIn, iblockstate2, j, 4 + i, 5 - i, structureBoundingBoxIn);
                }
            }
        }

        this.func_175804_a(worldIn, structureBoundingBoxIn, 3, 4, 5, 3, 4, 10, iblockstate5, iblockstate5, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 7, 4, 2, 7, 4, 10, iblockstate5, iblockstate5, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 4, 5, 4, 4, 5, 10, iblockstate5, iblockstate5, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 6, 5, 4, 6, 5, 10, iblockstate5, iblockstate5, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 5, 6, 3, 5, 6, 10, iblockstate5, iblockstate5, false);

        for (int k = 4; k >= 1; --k) {
            this.func_175811_a(worldIn, iblockstate5, k, 2 + k, 7 - k, structureBoundingBoxIn);

            for (int k1 = 8 - k; k1 <= 10; ++k1) {
                this.func_175811_a(worldIn, iblockstate3, k, 2 + k, k1, structureBoundingBoxIn);
            }
        }

        this.func_175811_a(worldIn, iblockstate5, 6, 6, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate5, 7, 5, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 6, 6, 4, structureBoundingBoxIn);

        for (int l = 6; l <= 8; ++l) {
            for (int l1 = 5; l1 <= 10; ++l1) {
                this.func_175811_a(worldIn, iblockstate4, l, 12 - l, l1, structureBoundingBoxIn);
            }
        }

        this.func_175811_a(worldIn, iblockstate6, 0, 2, 1, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate6, 0, 2, 4, structureBoundingBoxIn);

        this.func_175811_a(worldIn, iblockstate6, 4, 2, 0, structureBoundingBoxIn);
//        this.setBlockState(worldIn, Blocks.GLASS_PANE.getDefaultState(), 0, 2, 2, structureBoundingBoxIn);
//        this.setBlockState(worldIn, Blocks.GLASS_PANE.getDefaultState(), 0, 2, 3, structureBoundingBoxIn);
//        this.setBlockState(worldIn, Blocks.GLASS_PANE.getDefaultState(), 5, 2, 0, structureBoundingBoxIn);
//        this.setBlockState(worldIn, Blocks.GLASS_PANE.getDefaultState(), 8, 2, 2, structureBoundingBoxIn);
//        this.setBlockState(worldIn, Blocks.GLASS_PANE.getDefaultState(), 8, 2, 3, structureBoundingBoxIn);
//        this.setBlockState(worldIn, Blocks.GLASS_PANE.getDefaultState(), 8, 2, 7, structureBoundingBoxIn);
//        this.setBlockState(worldIn, Blocks.GLASS_PANE.getDefaultState(), 8, 2, 8, structureBoundingBoxIn);
//        this.setBlockState(worldIn, Blocks.GLASS_PANE.getDefaultState(), 2, 2, 7, structureBoundingBoxIn);
//        this.setBlockState(worldIn, Blocks.GLASS_PANE.getDefaultState(), 2, 2, 8, structureBoundingBoxIn);
//        this.setBlockState(worldIn, Blocks.GLASS_PANE.getDefaultState(), 5, 4, 10, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 0, 2, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 0, 2, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 5, 2, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 8, 2, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 8, 2, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 8, 2, 7, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 8, 2, 8, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 2, 2, 7, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 2, 2, 8, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 5, 4, 10, structureBoundingBoxIn);

        this.func_175811_a(worldIn, iblockstate6, 6, 2, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate6, 8, 2, 1, structureBoundingBoxIn);


        this.func_175811_a(worldIn, iblockstate6, 8, 2, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate5, 8, 2, 5, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate6, 8, 2, 6, structureBoundingBoxIn);


        this.func_175811_a(worldIn, iblockstate6, 8, 2, 9, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate6, 2, 2, 6, structureBoundingBoxIn);


        this.func_175811_a(worldIn, iblockstate6, 2, 2, 9, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate6, 4, 4, 10, structureBoundingBoxIn);

        this.func_175811_a(worldIn, iblockstate6, 6, 4, 10, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate5, 5, 5, 10, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 2, 1, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 2, 2, 0, structureBoundingBoxIn);
        this.func_189926_a(worldIn, EnumFacing.NORTH, 2, 3, 1, structureBoundingBoxIn);
        //this.createVillageDoor(worldIn, structureBoundingBoxIn, randomIn, 2, 1, 0, EnumFacing.NORTH); //nah
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 0, -1, 3, 2, -1, Blocks.field_150350_a.func_176223_P(), Blocks.field_150350_a.func_176223_P(), false);

        if (this.func_175807_a(worldIn, 2, 0, -1, structureBoundingBoxIn).func_185904_a() == Material.field_151579_a && this.func_175807_a(worldIn, 2, -1, -1, structureBoundingBoxIn).func_185904_a() != Material.field_151579_a) {
            this.func_175811_a(worldIn, iblockstate1, 2, 0, -1, structureBoundingBoxIn);

            if (this.func_175807_a(worldIn, 2, -1, -1, structureBoundingBoxIn).func_177230_c() == Blocks.field_185774_da) {
                this.func_175811_a(worldIn, Blocks.field_150349_c.func_176223_P(), 2, -1, -1, structureBoundingBoxIn);
            }
        }

        for (int i1 = 0; i1 < 5; ++i1) {
            for (int i2 = 0; i2 < 9; ++i2) {
                this.func_74871_b(worldIn, i2, 7, i1, structureBoundingBoxIn);
                this.func_175808_b(worldIn, iblockstate, i2, -1, i1, structureBoundingBoxIn);
            }
        }

        for (int j1 = 5; j1 < 11; ++j1) {
            for (int j2 = 2; j2 < 9; ++j2) {
                this.func_74871_b(worldIn, j2, 7, j1, structureBoundingBoxIn);
                this.func_175808_b(worldIn, iblockstate, j2, -1, j1, structureBoundingBoxIn);
            }
        }

        this.func_74893_a(worldIn, structureBoundingBoxIn, 4, 1, 2, 2);
        return true;
    }

    @Override
    public StructureVillagePieces.PieceWeight getVillagePieceWeight(Random random, int size) {
        return new StructureVillagePieces.PieceWeight(House.class, 8, MathHelper.func_76136_a(random, size, 3 + size * 2));
    }

    @Override
    public Class<?> getComponentClass() {
        return House.class;
    }

    @Override
    public StructureVillagePieces.Village buildComponent(StructureVillagePieces.PieceWeight villagePiece, StructureVillagePieces.Start startPiece, List<StructureComponent> pieces, Random random, int p1, int p2, int p3, EnumFacing facing, int p5) {
        StructureBoundingBox structureboundingbox = StructureBoundingBox.func_175897_a(p1, p2, p3, 0, 0, 0, 9, 7, 12, facing);
        return func_74895_a(structureboundingbox) && StructureComponent.func_74883_a(pieces, structureboundingbox) == null ? new House(startPiece, p5, random, structureboundingbox, facing) : null;
    }


}
