package betterwithmods.common.world.gen.village;

import net.minecraft.block.BlockStairs;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.MathHelper;
import net.minecraft.world.World;
import net.minecraft.world.gen.structure.StructureBoundingBox;
import net.minecraft.world.gen.structure.StructureComponent;
import net.minecraft.world.gen.structure.StructureVillagePieces;
import net.minecraft.world.gen.structure.template.TemplateManager;

import javax.annotation.Nonnull;
import java.util.List;
import java.util.Random;

/**
 * Created by primetoxinz on 5/21/17.
 */
public class Hut extends AbandonedVillagePiece {
    private boolean isTallHouse;
    private int tablePosition;

    public Hut() {
    }

    public Hut(StructureVillagePieces.Start start, int type, Random rand, StructureBoundingBox structurebb, EnumFacing facing) {
        super(start, type);
        this.func_186164_a(facing);
        this.field_74887_e = structurebb;
        this.isTallHouse = rand.nextBoolean();
        this.tablePosition = rand.nextInt(3);
    }

    @Override
    public Class<?> getComponentClass() {
        return Hut.class;
    }

    /**
     * (abstract) Helper method to write subclass data to NBT
     */
    protected void func_143012_a(NBTTagCompound tagCompound) {
        super.func_143012_a(tagCompound);
        tagCompound.func_74768_a("T", this.tablePosition);
        tagCompound.func_74757_a("C", this.isTallHouse);
    }

    /**
     * (abstract) Helper method to read subclass data from NBT
     */
    protected void func_143011_b(NBTTagCompound tagCompound, TemplateManager p_143011_2_) {
        super.func_143011_b(tagCompound, p_143011_2_);
        this.tablePosition = tagCompound.func_74762_e("T");
        this.isTallHouse = tagCompound.func_74767_n("C");
    }

    /**
     * second Part of Structure generating, this for example places Spiderwebs, Mob Spawners, it closes
     * Mineshafts at the end, it adds Fences...
     */
    public boolean func_74875_a(@Nonnull World worldIn, @Nonnull Random randomIn, @Nonnull StructureBoundingBox structureBoundingBoxIn) {
        if (this.field_143015_k < 0) {
            this.field_143015_k = this.func_74889_b(worldIn, structureBoundingBoxIn);

            if (this.field_143015_k < 0) {
                return true;
            }

            this.field_74887_e.func_78886_a(0, this.field_143015_k - this.field_74887_e.field_78894_e + 6 - 1, 0);
        }

        IBlockState primary = this.func_175847_a(Blocks.field_150347_e.func_176223_P());
        IBlockState secondary = this.func_175847_a(Blocks.field_150344_f.func_176223_P());
        IBlockState stair = this.func_175847_a(Blocks.field_150446_ar.func_176223_P().func_177226_a(BlockStairs.field_176309_a, EnumFacing.NORTH));
        IBlockState supports = this.func_175847_a(Blocks.field_150364_r.func_176223_P());
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 1, 1, 3, 5, 4, Blocks.field_150350_a.func_176223_P(), Blocks.field_150350_a.func_176223_P(), false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 0, 0, 3, 0, 4, primary, primary, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 0, 1, 2, 0, 3, Blocks.field_150346_d.func_176223_P(), Blocks.field_150346_d.func_176223_P(), false);

        if (this.isTallHouse) {
            this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 4, 1, 2, 4, 3, supports, supports, false);
        } else {
            this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 5, 1, 2, 5, 3, supports, supports, false);
        }

        this.func_175811_a(worldIn, supports, 1, 4, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, supports, 2, 4, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, supports, 1, 4, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, supports, 2, 4, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, supports, 0, 4, 1, structureBoundingBoxIn);
        this.func_175811_a(worldIn, supports, 0, 4, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, supports, 0, 4, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, supports, 3, 4, 1, structureBoundingBoxIn);
        this.func_175811_a(worldIn, supports, 3, 4, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, supports, 3, 4, 3, structureBoundingBoxIn);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 1, 0, 0, 3, 0, supports, supports, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 3, 1, 0, 3, 3, 0, supports, supports, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 1, 4, 0, 3, 4, supports, supports, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 3, 1, 4, 3, 3, 4, supports, supports, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 1, 1, 0, 3, 3, secondary, secondary, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 3, 1, 1, 3, 3, 3, secondary, secondary, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 1, 0, 2, 3, 0, secondary, secondary, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 1, 4, 2, 3, 4, secondary, secondary, false);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 0, 2, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 3, 2, 2, structureBoundingBoxIn);
        if (tablePosition > 0)
            this.func_175811_a(worldIn, primary, this.tablePosition, 1, 3, structureBoundingBoxIn);

        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 1, 1, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 1, 2, 0, structureBoundingBoxIn);

        if (this.func_175807_a(worldIn, 1, 0, -1, structureBoundingBoxIn).func_185904_a() == Material.field_151579_a && this.func_175807_a(worldIn, 1, -1, -1, structureBoundingBoxIn).func_185904_a() != Material.field_151579_a) {
            this.func_175811_a(worldIn, stair, 1, 0, -1, structureBoundingBoxIn);

            if (this.func_175807_a(worldIn, 1, -1, -1, structureBoundingBoxIn).func_177230_c() == Blocks.field_185774_da) {
                this.func_175811_a(worldIn, Blocks.field_150349_c.func_176223_P(), 1, -1, -1, structureBoundingBoxIn);
            }
        }

        for (int i = 0; i < 5; ++i) {
            for (int j = 0; j < 4; ++j) {
                this.func_74871_b(worldIn, j, 6, i, structureBoundingBoxIn);
                this.func_175808_b(worldIn, primary, j, -1, i, structureBoundingBoxIn);
            }
        }

        this.func_74893_a(worldIn, structureBoundingBoxIn, 1, 1, 2, 1);
        return true;
    }

    @Override
    public StructureVillagePieces.PieceWeight getVillagePieceWeight(Random random, int size) {
        return new StructureVillagePieces.PieceWeight(Hut.class, 3, MathHelper.func_76136_a(random, 2 + size, 5 + size * 3));
    }

    @Override
    public StructureVillagePieces.Village buildComponent(StructureVillagePieces.PieceWeight villagePiece, StructureVillagePieces.Start startPiece, List<StructureComponent> pieces, Random random, int p1, int p2, int p3, EnumFacing facing, int p5) {
        StructureBoundingBox structureboundingbox = StructureBoundingBox.func_175897_a(p1, p2, p3, 0, 0, 0, 4, 6, 5, facing);
        return func_74895_a(structureboundingbox) && StructureComponent.func_74883_a(pieces, structureboundingbox) == null ? new Hut(startPiece, p5, random, structureboundingbox, facing) : null;
    }


}
