package betterwithmods.module.gameplay.miniblocks.tiles;

import betterwithmods.common.blocks.camo.TileCamo;
import betterwithmods.module.gameplay.miniblocks.blocks.BlockMini;
import betterwithmods.module.gameplay.miniblocks.orientations.BaseOrientation;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public abstract class TileMini extends TileCamo {

    public BaseOrientation orientation;

    public TileMini() {
    }

    @Override
    public boolean shouldRefresh(World world, BlockPos pos, @Nonnull IBlockState oldState, @Nonnull IBlockState newState) {
        return oldState.func_177230_c() != newState.func_177230_c();
    }

    @Nonnull
    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound compound) {
        NBTTagCompound tag = super.func_189515_b(compound);
        if (orientation != null) {
            tag.func_74768_a("orientation", orientation.ordinal());
        }
        return tag;
    }

    public BaseOrientation deserializeOrientation(NBTTagCompound tag) {
        if (tag.func_74764_b("orientation")) {
            int o = tag.func_74762_e("orientation");
            return this.deserializeOrientation(o);
        }
        return BaseOrientation.DEFAULT;
    }

    @Override
    public void func_145839_a(NBTTagCompound compound) {
        super.func_145839_a(compound);
        orientation = deserializeOrientation(compound);
    }

    @Override
    public void onPlacedBy(EntityLivingBase placer, @Nullable EnumFacing face, ItemStack stack, float hitX, float hitY, float hitZ) {
        super.onPlacedBy(placer, face, stack, hitX, hitY, hitZ);
        if (func_145838_q() instanceof BlockMini) {
            orientation = ((BlockMini) func_145838_q()).getOrientationFromPlacement(placer, face, stack, hitX, hitY, hitZ);
        }
    }

    public boolean changeOrientation(BaseOrientation newOrientation, boolean simulate) {
        if (orientation != newOrientation) {
            if (!simulate) {
                orientation = newOrientation;
                markBlockForUpdate();
                func_145831_w().func_175722_b(field_174879_c, func_145838_q(), true);
            }
            return true;
        } else {
            return false;
        }
    }

    public BaseOrientation getOrientation() {
        if (orientation == null)
            return BaseOrientation.DEFAULT;
        return orientation;
    }

    public abstract BaseOrientation deserializeOrientation(int ordinal);

}
