package betterwithmods.module.hardcore.needs;

import betterwithmods.BWMod;
import betterwithmods.common.BWRegistry;
import betterwithmods.common.penalties.ArmorPenalties;
import betterwithmods.module.Feature;
import betterwithmods.util.IngredientMap;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;

/**
 * Created by primetoxinz on 5/10/17.
 */
public class HCArmor extends Feature {
    public static final IngredientMap<Integer> weights = new IngredientMap<>(0);

    public static ArmorPenalties penalties;

    public static boolean shieldRebalance;

    public static float getWeight(ItemStack stack) {
        if (!BWMod.MODULE_LOADER.isFeatureEnabled(HCArmor.class))
            return 0;
        return weights.findValue(stack);
    }

    public static void initWeights() {
        weights.put(Items.field_151020_U, 3);
        weights.put(Items.field_151023_V, 4);
        weights.put(Items.field_151022_W, 4);
        weights.put(Items.field_151029_X, 2);

        weights.put(Items.field_151028_Y, 5);
        weights.put(Items.field_151030_Z, 8);
        weights.put(Items.field_151165_aa, 7);
        weights.put(Items.field_151167_ab, 4);

        weights.put(Items.field_151161_ac, 5);
        weights.put(Items.field_151163_ad, 8);
        weights.put(Items.field_151173_ae, 7);
        weights.put(Items.field_151175_af, 4);

        weights.put(Items.field_151169_ag, 5);
        weights.put(Items.field_151171_ah, 8);
        weights.put(Items.field_151149_ai, 7);
        weights.put(Items.field_151151_aj, 4);
    }

    @Override
    public void init(FMLInitializationEvent event) {
        initWeights();
    }

    @Override
    public boolean hasSubscriptions() {
        return true;
    }

    @Override
    public void setupConfig() {
        shieldRebalance = loadPropBool("Shield Rebalance", "Experimental recipes for rebalacing shields", false);
    }

    @Override
    public void preInit(FMLPreInitializationEvent event) {
        BWRegistry.PENALTY_HANDLERS.add(penalties = new ArmorPenalties());
    }

    @Override
    public String getFeatureDescription() {
        return "Gives Armor weight values that effect movement. Changes Entity armor spawning: Zombies only spawn with Iron armor, Skeletons never wear armor.";
    }
}
