package betterwithmods.testing;

import betterwithmods.common.registry.block.managers.CraftingManagerSaw;
import betterwithmods.common.registry.block.recipe.BlockDropIngredient;
import betterwithmods.common.registry.block.recipe.BlockIngredient;
import betterwithmods.common.registry.block.recipe.SawRecipe;
import betterwithmods.testing.base.BaseBlockTest;
import betterwithmods.testing.base.Before;
import betterwithmods.testing.base.Test;
import betterwithmods.testing.base.world.FakeWorld;
import com.google.common.collect.Lists;
import net.minecraft.block.BlockLog;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;

import java.util.List;

public class SawRecipesTest extends BaseBlockTest<SawRecipe> {

    @Before
    @Override
    public void beforeTest() {
        world = new FakeWorld();

        TEST_MANAGER = new CraftingManagerSaw();
        world.func_175656_a(origin, Blocks.field_150344_f.func_176223_P());
        world.func_175656_a(origin.func_177984_a(), Blocks.field_150364_r.func_176223_P().func_177226_a(BlockLog.field_176299_a, BlockLog.EnumAxis.X));

        BlockIngredient dropIngredient = new BlockDropIngredient("logWood");

        BlockIngredient ingredient = new BlockIngredient(Blocks.field_150344_f.func_176223_P());
        BlockIngredient oreIngredient = new BlockIngredient("plankWood");

        List<ItemStack> outputs = Lists.newArrayList(new ItemStack(Items.field_151042_j));
        recipe = new SawRecipe(ingredient, outputs);
        oreRecipe = new SawRecipe(oreIngredient, outputs);
        blockDropRecipe = new SawRecipe(dropIngredient, outputs);
    }

    @Test
    public void testLogs() {

        List<IBlockState> states = Blocks.field_150364_r.func_176194_O().func_177619_a();
        for(IBlockState state: states) {
            world.func_175656_a(origin.func_177984_a(), state);
            testRecipe(blockDropRecipe, origin.func_177984_a());
        }

    }
}
